public class Branch extends DrawableNode {
  /*
   * A list of children to draw
   */
  public DrawableNode children;

  /*
   * Construct a branch with children and
   * next as null
   **/
  public Branch(){
    super(); // Call superclass constructor
    children = null;
  }
  
  /**
   * Method to return a string with informaiton 
   * about this branch
   */
  public String toString() 
  {
    String childString = "No children", nextString="No next";
    if (children != null)
    {childString = children.toString();}
    if (next != null)
    {nextString = next.toString();}
    
    return "Branch (with child: "+childString+" and next: "+
      nextString+")";
  }

  /**
   * Method to add nodes to children
   **/
  public void addChild(DrawableNode child){
    if (children != null)
    {children.add(child);}
      else
      {children = child;}
  }
  
  /*
   * Ask all our children to draw,
   * then let next draw.
   * @param pen Turtle to draw with
   **/
  public void drawWith(Turtle pen){
    DrawableNode current = children;
    
    // Tell the children to draw
    while (current != null){
      current.drawWith(pen);
      current = (DrawableNode) current.getNext();//Cast
    }
    
    // Tell my next to draw
    if (this.getNext() != null)
    {current = (DrawableNode) this.getNext();
      current.drawWith(pen);//Cast
    }
  }
}