/**
 * Stuff that all nodes and branches in the
 * scene tree know.
 **/
abstract public class DrawableNode extends LLNode {

  
  /**
   * Use the given turtle to draw oneself
   * @param t the Turtle to draw with
   **/
  abstract public void drawWith(Turtle t);
  // No body in the superclass
  
  /**
   * Draw on the given picture
   **/
  public void drawOn(Picture bg){
    Turtle t = new Turtle(bg);
    t.setPenDown(false);
    this.drawWith(t);
  }


}
    
