public class HBranch extends Branch {

  /**
   * Horizontal gap between children
   **/
  int gap;
  
  /*
   * Construct a branch with children and
   * next as null
   **/
  public HBranch(int spacing){
    super(); // Call superclass constructor
    gap = spacing;
  }
  
  /**
   * Method to return a string with informaiton 
   * about this branch
   */
  public String toString() 
  {
    return "Horizontal "+super.toString();
  }
  
  /*
   * Ask all our children to draw,
   * then let next draw.
   * @param pen Turtle to draw with
   **/
  public void drawWith(Turtle pen){
    DrawableNode current = children;
    
    // Have my children draw
    while (current != null){
      current.drawWith(pen);
      pen.moveTo(pen.getXPos()+gap,pen.getYPos());
      current = (DrawableNode) current.getNext();
    }
    
    // Have my next draw
    if (this.getNext() != null)
    {current = (DrawableNode) this.getNext();
      current.drawWith(pen);}
  }
}